library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use ieee.numeric_std.all;

entity fsm is
	port(
		clk	: in std_logic;
		cordicstart : in std_logic;
		fsminit : in std_logic; -- initialisation de la fsm en cas de probleme
		angle	: in std_logic_vector(15 downto 0);
		sin	: out std_logic_vector(15 downto 0);
		cos	: out std_logic_vector(15 downto 0);
		cordicdone : out std_logic);
end entity;

architecture behavior of fsm is

begin

-- sequenceur
cordic_seq:	process(clk,fsminit) begin
		if fsminit='1' then
			state <= e0;
		elsif rising_edge(clk) then
			case state is
				when e0	=>	if cordicstart='1' then
									state <= e1;
								else
									state <= e0;
								end if;
				when e1	=>	if i=maxit then
									state <= e2;
								else
									state <= e1;
								end if;
				when e2	=>	if cordicstart='0' then
									state <=	e0;
								else
									state <= e2;
								end if;
				when others => state <= e0;
			end case;
		end if;
	end process;

--actions du sequenceur
	initcordic <= '1' when state=e0 else '0';
	encordic <= '1' when state=e1 else '0';
	cordicdone <= '1' when state=e2 else '0';
	
	end behavior;